#!/bin/bash

if [ $(basename $0) = $(basename ${BASH_SOURCE}) ]; then # 単独で実行
    alone=1 
else
    alone=0
fi

if [ ! -x /usr/bin/curl ] ; then
    echo "[Warning] No \"curl\"! News Feed function is disabled."
    nf=0
    [ ${alone} -eq 0 ] && return $(false)
    exit 1
fi

# LOCALEが日本語で無い時はwf=0にすべきか、ここでLOCALEを設定する
export LANG=ja_JP.UTF-8 

cnews=0

gettitles() {
    local tag element
    local i=0
    curl -s https://news.yahoo.co.jp/pickup/rss.xml |
    sed -e 's/&amp;/\&/g' |
    while IFS=$'>' read -d '<' tag element ; do
        if [[ "${tag}" = "item" ]]; then
            i=1
        elif [[ ${i} == 1 && "${tag}" = "title" ]]; then
            echo ${element}
            i=0
        fi
    done
}

getanews() {  # 1行取得する
    [ ${#news[@]} -gt 0 ] || return
    echo -n ${news[cnews]}
    let cnews++
    let cnews%=${#news[@]}
}

getnewsil() { # $1行取得する 改行なし
    local i
    for ((i=0; i<nf; i++)) {
        getanews ; echo -n ". "
    }
}

getnews() { # $1行取得する
    local i
    for ((i=0; i<nf; i++)) {
        getanews; echo
    }
}

feed() {
    IFS=$'\n' news=( $( gettitles ) )
    let cnews=0
}

updatecnews() {
    let cnews+=${nf}       # この処理は、前の処理が子プロセスあつかいで、
    let cnews%=${#news[@]} # cnews更新の副作用が働かないときに呼び出す
}


if [ ${alone} -eq 1 ]; then # 単独で実行
    unset alone
    nf=3
    echo "ニュース取得中"
    feed
    echo ${#news[@]}
    getnews
    echo "${cnews}"
    getnews
    echo "${cnews}"
    getnews
    echo "${cnews}"
    getnews
else
    unset alone
    echo "[Info] feeding news. (${nf})"
    true
fi
